#include <iostream>

using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);

    int n, q;
    cin>>n>>q;
    int niz[n];

    for(int i=0; i<n; i++){
        cin>>niz[i];
    }

    for(int k=0; k<q; k++){
        int l, r;
        cin>>l>>r;

        int rez = 1;
        for(int j=l-1; j<r; j++){
            if(niz[j] == 0){
                rez=0;
                break;
            }
        }
        cout<<rez<<endl;
    }

    return 0;
}